# tclbabel/tkbabel core - version 0.56
# pretty much total rewrite of below
# by Chris "Danish" <dadanish@usa.net>

package require -exact http 1.0

proc Init {} {
	global env
	if {![catch "set env(http_proxy)"]} {
		set proxyurl $env(http_proxy)
		if {[string length $proxyurl] != 0} {
			if {[string match "*/" $proxyurl]} { append proxyurl / }
			if {![regexp -nocase {^(http://)?([^:/]+):(([0-9])+)?(/.*)} \
				$proxyurl x protocol server port path]} {
					error "bad url for proxy: $proxyurl"
				}
			if {$port == 0 || $port == ""} { set port 80 }
			http_config -proxyfilter httpProxyRequired -proxyhost $server -proxyport $port
		}
	}
}

proc doHttp {lang text} {
#	set regexp "\<br\>\n+\<font face\=\"arial, helvetica\"\>(.+)\n\<br\>\<br\>\<\/font\>\<\/td\>\<\/tr\>"
	set regexp "\<form action=\"http:\/\/altavista.com\/cgi-bin\/query\" method=get\>\n\<textarea rows=\"3\" wrap=virtual cols=\"56\" name=\"q\"\>\n(.+)\n\n\</textarea\>"
 

	set querytext [http_formatQuery doit done lp "$lang" urltext "$text"]
	set token [http_get {http://babelfish.altavista.com/translate.dyn} -query $querytext]
	upvar #0 $token state
#	puts $state(body)
	regexp "$regexp" $state(body) match translated
	return $translated
}

proc Trans {lang text} {
	global isGUI
	regsub -all "2" $lang "_" lang
	regsub -all "e" $lang "en" lang
	regsub -all "s" $lang "es" lang
	regsub -all "g" $lang "de" lang
	regsub -all "p" $lang "pt" lang
	regsub -all "f" $lang "fr" lang
	regsub -all "i" $lang "it" lang
	
	if {$lang == ""} { error "language invalid or not specified\ne2f - english to french\ne2g - english to german\ne2i - english to italian\ne2p - english to portuguese\ne2s - english to spanish\nReverse letters to reverse translation order" }
	if {$text == ""} { error "no translation text specified" }
	
	if {[string length $text] <= 1001} { return [doHttp $lang $text] } \
	else {
		set alltext [split $text \n]
		set currentout ""
		for {set i 0} {$i <= [expr [llength $alltext] - 1]} { incr i 1 } {
			set element [lindex $alltext $i]
			if {[expr [string length $currentout] + [string length $element]] < 1001 } {
				append currentout " $element"
				if {$i == [expr [llength $alltext] - 1]} { append translated [doHttp $lang $currentout]}
			} else {
				append translated [doHttp $lang $currentout]
				set currentout ""
				if {$isGUI} { .lang.r.light configure -foreground yellow4 -text "Connected,\nline $i of [expr [llength $alltext] - 1] complete"
				} else { puts stderr "Currently on line $i of [expr [llength $alltext] - 1]" }

			}
		}
		return $translated
	}
	
}
Init
# [09:12] <jazzfan> danish: foreach $element (@list) { #dunno the function for a
#   string's length, just assume it's length() if ((length($element)) +
#   (length($currentout)) < 1000) { $currentout .= $element; } else {
#   get(htmldocument); undef($currentout); } } 

